<!doctype html>
<html>
  <head>
    <meta charset="utf-8">
    <title>Vedavaapi TextDoc Editor</title>
    <link rel="stylesheet" href="fonts.css"/>
    <link rel="stylesheet" href="main.css"/>
    <link rel="stylesheet" href="vvm.css"/>
    <link rel="stylesheet" type="text/css" href="tinytabs.css"/>
        <!--link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css"-->
        <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css">
      <script type="text/javascript" src="tinytabs.min.js"></script>
    <script src="https://unpkg.com/@vedavaapi/kaveri-context@0.0.8/dist-iife/kcontext.js"></script>
    <script>

        function checkStatus(response) {
                if (response.ok) {
                    return Promise.resolve(response);
                }
                return Promise.reject(response);
            }

            function jsonify(response) {
                return response.json();
            }

            function onDOMLoaded(callback) {
                if (document.readyState != 'loading') callback();
                else document.addEventListener('DOMContentLoaded', callback);
            }

    </script>
    <script src="apps-helper.js"></script>
    <script src="objstore.js"></script>
    <script src="textdoc_editor.js"></script>
    <!--script src="//cdn.ckeditor.com/4.12.1/standard/ckeditor.js"></script-->
  </head>
  <body>

    <header id="header">
      <img src="https://www.vedavaapi.org/wp-content/uploads/2019/04/cropped-Vedavaapi-Handover-295x163.png" style="height: 9vh; margin-right: 2em; float: left;">
      <h2 style="float: left;">Vedavaapi TextDocs</h2>
      <ul style="list-style-type: none; float: right;" id="header-links-list">
        <li class="header-link-item">
            <button id="refresh-auth-button">
                ↻
                <span max="100" id="refresh-auth-progress">Relogin</span>
            </button>
        </li>
        <li class="header-link-item">
          <a href="" id="site-link" class="header-link" target="_blank">site<!--🔗-->➚</a>
        </li>
        <li class="header-link-item">
          <a href="" id="console-link" class="header-link" target="_blank">console➚</a>
        </li>
      </ul>
      <div style="float: clear;"></div>
    </header>

    <!--div id="layout-div"-->
    <div id="actions-div">
        <h3 style="background-color: lightblue; margin: 0em; padding: 0.2em; color: steelblue;">Context</h3><hr>
        <!--div id="miniview-action-div" class="action-div">
            <h4 class="action-name">Mini View</h5>
                <div class="action-body" id="miniview-body">
                    
                </div>
        </div-->
        <div id="sel-elem-view-actions-div" class="action-div">
            <div id="viewer-context-actions" class="action-body">
                <div id="viewer-sel-elem-info" class="cnt-section">
                    <h3 class="cnt-title">Info</h3>
                    <div id="sel-elem-view-action-body"></div>
                </div>

                <div id="viewer-elem-sel-annos" class="cnt-section">
                    <h3 class="cnt-title">Annos</h3>
                    <div id="sel-elem-anno-wrapper">
                        <div id="cnt-anno-sel-view" class="cnt-anno-section"></div>
                        <div id="cnt-anno-creator"class="cnt-anno-section" style="display: none;">
                            <div id="cnt-anno-plus" style="text-align: center; cursor: pointer;">+NEW</div>
                            <span id="cnt-anno-new-status" style="display: none;"></span>
                            
                        </div>
                        <div id="cnt-anno-generator" style="display: none;" class="cnt-anno-section">
                            <div id="cnt-generate-label">Analyze & Generate</div>
                            <div id="cnt-anno-generation-status-block">
                                <span id="cnt-anno-gen-status"></span>
                            </div>
                            <div id="cnt-anno-gen-actions">
                                <div id="cnt-anno-morph" style="text-align: center;" class="pointable anno-generate-action" data-analysis="morph">
                                    SAMSADHANI MORPH
                                </div>
                            </div>
                        </div>
                        <div id="cnt-annos"class="cnt-anno-section">
                            <span id="cnt-annos-status"></span>
                            <div id="cnt-annos-list">

                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div id="sel-elem-view-link" class="action-links">
                <p id="sel-elm-origin-link">
                    <button id="sel-elem-origin-link-button" style="display: none;">Show Origin Image</button>
                </p>
            </div>
        </div>

        <div id="origin-view-action-div" class="action-div" style="display: none;">
            <h4 class="action-name">Origin Info</h4>
            <div class="action-body" id="origin-view-action-body">
                <div id="origins"></div>
            </div>
        </div>
    </div>

    <div id="layout-vertical-divider"></div>

    <div id="main-div">
        <div id="markup-editor" class="section">
            <h3 class="title">Editor</h3>
            <div class="toolbar">
                <span class="title-cell"></span>
                <span id="status-cell" style="display: inline-block;"></span>
                <button id="button-save">Save</button>
            </div>
            <div id="editor-container" >
                <textarea id="editor1" name="editor1"></textarea>
            </div>
        </div>
        <div id="html-viewer" class="section">
            <h3 class="title">Viewer</h3>
            <div class="toolbar">
                <span class="title-cell"></span>
                <span id="html-status-cell"></span>
            </div>
            <div id="html-view-container" style="display: none;">
                <div id="html-view-actions">
                    <span id="html-view-expand-all" class="html-view-action">Expand All</span>
                    <span id="html-view-collapse-all" class="html-view-action">Collapse All</span>
                </div>
                <!--div id="html-view-annos-wrapper"-->
                    <div id="html-view-document-container"></div>
                <!--/div-->
            </div>
        </div>
        <div id="meta-viewer" class="section">
            <h3 class="title">Meta</h3>
            <div class="toolbar">
                <!--span class="title-cell"></span-->
                <span id="meta-status-cell"></span>
            </div>
            <div id="meta-view-container">
                
            </div>
        </div>
    </div>

    <div id="edit-div">
        <div id="edit-ibar">
            <span>Edit| </span>
            <span id="edit-status"></span>
            <span id="edit-body-toggle">+</span>
        </div>
        <div id="edit-body">
            <div id="edit-schema-options-wrapper">
                <select id="edit-schema-select"></select>
                <label>
                    create choice 
                    <input type="checkbox" name="asChoice" id="edit-as-choice">
                </label>
            </div>
            <div id="edit-js-form-wrapper">
                <div id="edit-js-form"></div>
            </div>
            <div id="edit-submit-wrapper">
                <button id="edit-submit"></button>
            </div>
        </div>
    </div>
    <!--/div-->

    <script src="https://cdn.tiny.cloud/1/no-api-key/tinymce/5/tinymce.min.js" referrerpolicy="origin"></script>
    <script src="https://cdn.jsdelivr.net/npm/@json-editor/json-editor@latest/dist/jsoneditor.min.js"></script>

    <script type="text/javascript">
        let loadingSvg = `<svg version="1.1" id="loader-1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px"
           width="20px" style="top:10px;" height="20px" viewBox="0 0 40 40" enable-background="new 0 0 40 40" xml:space="preserve">
          <path opacity="0.2" fill="#000" d="M20.201,5.169c-8.254,0-14.946,6.692-14.946,14.946c0,8.255,6.692,14.946,14.946,14.946
            s14.946-6.691,14.946-14.946C35.146,11.861,28.455,5.169,20.201,5.169z M20.201,31.749c-6.425,0-11.634-5.208-11.634-11.634
            c0-6.425,5.209-11.634,11.634-11.634c6.425,0,11.633,5.209,11.633,11.634C31.834,26.541,26.626,31.749,20.201,31.749z"/>
          <path fill="#000" d="M26.013,10.047l1.654-2.866c-2.198-1.272-4.743-2.012-7.466-2.012h0v3.312h0
            C22.32,8.481,24.301,9.057,26.013,10.047z">
            <animateTransform attributeType="xml"
              attributeName="transform"
              type="rotate"
              from="0 20 20"
              to="360 20 20"
              dur="0.5s"
              repeatCount="indefinite"/>
            </path>
          </svg>`;

        onDOMLoaded(function() {
            kContext = KContext.getInstance();
            tinytabs(document.getElementById('main-div'), {
                anchor: false,
                hideTitle: true
            });
            tinytabs(document.getElementById('viewer-context-actions'), {
                anchor: false,
                hideTitle: true,
                sectionClass: "cnt-section",
                tabsClass: "cnt-tabs",
                tabClass: "cnt-tab",
                titleClass: "cnt-title",
                selClass: "cnt-tab-sel"
            });

            let htmlViewContainer = document.getElementById('html-view-document-container');
            let actionsDiv = document.getElementById('actions-div');
            let actionsDivOffset = actionsDiv.offsetTop
            window.onscroll = function() {
                if(window.pageYOffset > actionsDivOffset) {
                    actionsDiv.classList.add('sticky-actions-div');
                }
                else {
                    actionsDiv.classList.remove('sticky-actions-div');
                }
            };

            function showSiteLinks() {
                document.getElementById('site-link').href = kContext.site;
                document.getElementById('console-link').href = kContext.url + '/';
                document.getElementById('header-links-list').style.display = 'block';
            }

            function setupManualRefresh() {
                const refreshButton = document.getElementById('refresh-auth-button');
                const refreshProgress = document.getElementById('refresh-auth-progress');

                refreshButton.addEventListener('click', () => {
                    refreshProgress.style.display = 'inline';
                    refreshProgress.style.color = 'blue';
                    refreshProgress.innerText = 'refreshing';
                    refreshButton.disabled = true;
                    kContext.getSession().then(() => {
                        refreshProgress.innerText = 'Success';
                        refreshProgress.style.color = 'green';
                        refreshButton.disabled =false;
                    }).catch(() => {
                        refreshProgress.innerText = 'Failure';
                        refreshProgress.style.color = 'red';
                        refreshButton.disabled =false;
                    }).then(() => {
                        setTimeout(() => {
                            refreshProgress.innerText = 'Relogin';
                            refreshProgress.style.color = 'black';
                        }, 5000);
                    });
                });
            }

            kContext.confirmWithServer().then(() => {
                showSiteLinks();

                setupManualRefresh();

                window.textDocHTMLViewer = new TextDocHTMLViewer({
                    containerId: 'html-view-document-container',
                    statusCellId: 'html-status-cell',
                    selElemViewId: 'sel-elem-view-action-body',
                    // miniViewDivId: 'miniview-body',
                    kContext,
                    textDocId: new URLSearchParams(document.location.search.substring(1)).get('_id'),
                    originsDivId: 'origins',
                    originToggleButtonId: 'sel-elem-origin-link-button',
                    originViewDivId: 'origin-view-action-div'
                });

                let setupHTMLView = function() {
                    document.getElementById('html-view-container').style.display = 'block';
                    document.getElementById('html-view-expand-all').addEventListener('click', () => {
                        textDocHTMLViewer.expandAll();
                    });
                    document.getElementById('html-view-collapse-all').addEventListener('click', () => {
                        textDocHTMLViewer.collapseAll();
                    });
                }

                document.querySelectorAll(`a[data-id='html-viewer']`).forEach((elem) => {
                    elem.addEventListener('click', (event) => {
                        if(!textDocHTMLViewer.html) {
                            textDocHTMLViewer.init().then((success) => {
                                if(!success) {
                                    return;
                                }
                                setupHTMLView();
                            });
                        }
                    });
                });

                window.textdocEditor = new TextDocumentEditor({
                    containerId: 'editor-container',
                    kContext,
                    textDocId: new URLSearchParams(document.location.search.substring(1)).get('_id'),
                    statusCellId: 'status-cell'
                }, (tde) => {
                    tde.init().then((success) => {
                        let metaStatusCell = document.getElementById('meta-status-cell');
                        if(success) {
                            let titleElems = document.getElementsByClassName('title-cell');
                            for(let te of titleElems) {
                                te.innerText = tde.textDoc.title;
                            }
                            metaStatusCell.inneerText = 'text doc retrieved';
                            window.metaViewer = new TextDocMetaViewer({
                                kContext,
                                containerId: 'meta-view-container',
                                textDoc: tde.textDoc
                            });
                            metaViewer.render();
                        }
                        else {
                            metaStatusCell.inneerText = 'error in retrieving text doc';
                        }
                    })
                });

                document.getElementById('button-save').addEventListener('click', () => textdocEditor.persist().then((result) => {
                        textDocHTMLViewer.updateHTML(result.html, textdocEditor.textDoc).then(() => {
                            if(document.getElementById('html-view-container').style.display == 'none') {
                                setupHTMLView();
                            }
                        });
                    })
                );

                window.annoEditor = new AnnoEditor({
                    kContext,
                    rootElem: document.getElementById('edit-div'),
                    ibarElem: document.getElementById('edit-ibar'),
                    statusElem: document.getElementById('edit-status'),
                    schemaSelectElem: document.getElementById('edit-schema-select'),
                    asChoiceElem: document.getElementById('edit-as-choice'),
                    bodyElem: document.getElementById('edit-body'),
                    formWrapperElem: document.getElementById('edit-js-form'),
                    toggleElem: document.getElementById('edit-body-toggle'),
                    submitElem: document.getElementById('edit-submit'),
                });

                annoEditor.getSchemas();

                window.annoManager = new AnnoManager({
                    kContext,
                    containerId: 'sel-elem-anno-wrapper',
                    annoEditor,
                });
                
                const debounce = (func, delay) => {
                    let inDebounce
                    return function () {
                        const context = this
                        const args = arguments
                        clearTimeout(inDebounce)
                        inDebounce = setTimeout(() => func.apply(context, args), delay)
                    }
                };

                htmlViewContainer.addEventListener('selchange', debounce(
                        (e) => {
                            console.log('selchange', e);
                            annoManager.onEvent(e);
                        },
                        300
                    )
                );
            });
        })
        
    </script>
  </body>
</html>
